> ## Documentation Index
> Fetch the complete documentation index at: https://docs.herondata.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Bulk save entity attribute values by entity name and attribute name

> Save multiple entity attribute values in a single request.
Each item specifies the entity name, attribute name, and value to set.
If an API source doesn't exist for an attribute, one will be created.




## OpenAPI

````yaml https://app.herondata.io/swagger put /api/end_users/{end_user_heron_id}/entities/values/bulk
openapi: 3.0.0
info:
  contact:
    email: support@herondata.io
    name: Support
  title: Heron Data API
  version: '2021-07-19'
servers:
  - description: Production
    url: https://app.herondata.io
security:
  - ApiKeyAuth:
      - key_XXX
externalDocs:
  description: Read Tutorial
  url: https://docs.herondata.io/
paths:
  /api/end_users/{end_user_heron_id}/entities/values/bulk:
    put:
      tags:
        - EndUserEntity
      summary: Bulk save entity attribute values by entity name and attribute name
      description: |
        Save multiple entity attribute values in a single request.
        Each item specifies the entity name, attribute name, and value to set.
        If an API source doesn't exist for an attribute, one will be created.
      parameters:
        - description: The Heron ID of the end user
          in: path
          name: end_user_heron_id
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/BulkSaveEntityAttributeValuesSchema'
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                items:
                  $ref: >-
                    #/components/schemas/BulkSaveEntityAttributeValueResultSchema
                type: array
          description: Results for each item in the bulk request
        '404':
          description: End user not found
      security:
        - ApiKeyAuth: []
components:
  schemas:
    BulkSaveEntityAttributeValuesSchema:
      properties:
        values:
          description: List of entity attribute values to save
          items:
            $ref: '#/components/schemas/BulkSaveEntityAttributeValueItem'
          type: array
      required:
        - values
      type: object
    BulkSaveEntityAttributeValueResultSchema:
      properties:
        attribute_name:
          description: Name of the attribute
          type: string
        entity_name:
          description: Name of the entity
          type: string
        error:
          description: Error message if the save failed
          nullable: true
          type: string
        success:
          description: Whether the value was saved successfully
          type: boolean
      required:
        - attribute_name
        - entity_name
        - success
      type: object
    BulkSaveEntityAttributeValueItem:
      properties:
        attribute_name:
          description: Name of the attribute to set the value for
          type: string
        entity_name:
          description: Name of the entity to target
          type: string
        value:
          description: The value to set for the attribute
          nullable: true
      required:
        - attribute_name
        - entity_name
        - value
      type: object
  securitySchemes:
    ApiKeyAuth:
      in: header
      name: x-api-key
      type: apiKey

````